diff --git a/unix/selector.c b/unix/selector.c
index 4251a25..d6cea65 100644
--- a/unix/selector.c
+++ b/unix/selector.c
@@ -52,6 +52,7 @@
 #include <syslog.h>
 #include <signal.h>
 #include <string.h>
+#include <assert.h>
 #ifdef HAVE_EPOLL_PWAIT
 #include <sys/epoll.h>
 #else
@@ -60,11 +61,23 @@
 #define EPOLL_CTL_MOD 0
 #endif
 
+struct sel_runner_s
+{
+    struct selector_s *sel;
+    sel_runner_func_t func;
+    void *cb_data;
+    int in_use;
+    sel_runner_t *next;
+};
+
 typedef struct fd_state_s
 {
     int               deleted;
     unsigned int      use_count;
     sel_fd_cleared_cb done;
+    sel_runner_t      done_runner;
+    int               tmp_fd;
+    void              *done_cbdata;
 } fd_state_t;
 
 /* The control structure for each file descriptor. */
@@ -78,6 +91,9 @@ typedef struct fd_control_s
     sel_fd_handler_t handle_read;
     sel_fd_handler_t handle_write;
     sel_fd_handler_t handle_except;
+#ifdef HAVE_EPOLL_PWAIT
+    uint32_t saved_events;
+#endif
 } fd_control_t;
 
 typedef struct heap_val_s
@@ -147,7 +163,7 @@ heap_cmp_key(heap_val_t *v1, heap_val_t *v2)
 
 /* Used to build a list of threads that may need to be woken if a
    timer on the top of the heap changes, or an FD is added/removed.
-   See wake_sel_thread() for more info. */
+   See i_wake_sel_thread() for more info. */
 typedef struct sel_wait_list_s
 {
     /* The thread to wake up. */
@@ -164,15 +180,6 @@ typedef struct sel_wait_list_s
     struct sel_wait_list_s *next, *prev;
 } sel_wait_list_t;
 
-struct sel_runner_s
-{
-    struct selector_s *sel;
-    sel_runner_func_t func;
-    void *cb_data;
-    int in_use;
-    sel_runner_t *next;
-};
-
 struct selector_s
 {
     /* This is an array of all the file descriptors possible.  This is
@@ -195,7 +202,7 @@ struct selector_s
     theap_t timer_heap;
 
     /* This is a list of items waiting to be woken up because they are
-       sitting in a select.  See wake_sel_thread() for more info. */
+       sitting in a select.  See i_wake_sel_thread() for more info. */
     sel_wait_list_t wait_list;
 
     void *timer_lock;
@@ -255,7 +262,7 @@ sel_fd_unlock(struct selector_s *sel)
    this after we have calculated the timeout, but before we have
    called select, thus only things in the wait list matter. */
 static void
-wake_sel_thread(struct selector_s *sel)
+i_wake_sel_thread(struct selector_s *sel)
 {
     sel_wait_list_t *item;
 
@@ -269,10 +276,18 @@ wake_sel_thread(struct selector_s *sel)
     }
 }
 
+void
+sel_wake_all(struct selector_s *sel)
+{
+    sel_timer_lock(sel);
+    i_wake_sel_thread(sel);
+    sel_timer_unlock(sel);
+}
+
 static void
 wake_fd_sel_thread(struct selector_s *sel)
 {
-    wake_sel_thread(sel);
+    sel_wake_all(sel);
     sel_fd_unlock(sel);
 }
 
@@ -281,7 +296,7 @@ wake_timer_sel_thread(struct selector_s *sel, volatile sel_timer_t *old_top)
 {
     if (old_top != theap_get_top(&sel->timer_heap))
 	/* If the top value changed, restart the waiting thread. */
-	wake_sel_thread(sel);
+	i_wake_sel_thread(sel);
 }
 
 /* Wait list management.  These *must* be called with the timer list
@@ -322,8 +337,9 @@ init_fd(fd_control_t *fd)
 
 #ifdef HAVE_EPOLL_PWAIT
 static int
-sel_update_epoll(struct selector_s *sel, int fd, int op)
+sel_update_epoll(struct selector_s *sel, int fd, int op, int read_enable)
 {
+    fd_control_t *fdc = (fd_control_t *) &sel->fds[fd];
     struct epoll_event event;
 
     if (sel->epollfd < 0)
@@ -332,24 +348,40 @@ sel_update_epoll(struct selector_s *sel, int fd, int op)
     memset(&event, 0, sizeof(event));
     event.events = EPOLLONESHOT;
     event.data.fd = fd;
-    if (FD_ISSET(fd, &sel->read_set))
-	event.events |= EPOLLIN | EPOLLHUP;
-    if (FD_ISSET(fd, &sel->write_set))
-	event.events |= EPOLLOUT;
-    if (FD_ISSET(fd, &sel->write_set))
-	event.events |= EPOLLERR | EPOLLPRI;
-
+    if (fdc->saved_events) {
+	if (!read_enable)
+	    return 0;
+	op = EPOLL_CTL_ADD;
+	event.events = EPOLLIN | EPOLLHUP;
+    } else {
+	if (FD_ISSET(fd, &sel->read_set))
+	    event.events |= EPOLLIN | EPOLLHUP;
+	if (FD_ISSET(fd, &sel->write_set))
+	    event.events |= EPOLLOUT;
+	if (FD_ISSET(fd, &sel->except_set))
+	    event.events |= EPOLLERR | EPOLLPRI;
+    }
     epoll_ctl(sel->epollfd, op, fd, &event);
     return 0;
 }
 #else
 static int
-sel_update_epoll(struct selector_s *sel, int fd, int op)
+sel_update_epoll(struct selector_s *sel, int fd, int op, int dummy)
 {
     return 1;
 }
 #endif
 
+static void
+finish_oldstate(sel_runner_t *runner, void *cbdata)
+{
+    fd_state_t *oldstate = cbdata;
+
+    if (oldstate->done)
+	oldstate->done(oldstate->tmp_fd, oldstate->done_cbdata);
+    free(oldstate);
+}
+
 /* Set the handlers for a file descriptor. */
 int
 sel_set_fd_handlers(struct selector_s *sel,
@@ -368,9 +400,10 @@ sel_set_fd_handlers(struct selector_s *sel,
     state = malloc(sizeof(*state));
     if (!state)
 	return ENOMEM;
-    state->deleted = 0;
-    state->use_count = 0;
+    memset(state, 0, sizeof(*state));
     state->done = done;
+    memset(&state->done_runner, 0, sizeof(state->done_runner));
+    state->done_runner.sel = sel;
 
     sel_fd_lock(sel);
     fdc = (fd_control_t *) &(sel->fds[fd]);
@@ -391,7 +424,7 @@ sel_set_fd_handlers(struct selector_s *sel,
 	    sel->maxfd = fd;
 	}
 
-	if (sel_update_epoll(sel, fd, EPOLL_CTL_ADD)) {
+	if (sel_update_epoll(sel, fd, EPOLL_CTL_ADD, 0)) {
 	    wake_fd_sel_thread(sel);
 	    goto out;
 	}
@@ -402,19 +435,16 @@ sel_set_fd_handlers(struct selector_s *sel,
     if (oldstate) {
 	oldstate->deleted = 1;
 	if (oldstate->use_count == 0) {
-	    if (oldstate->done)
-		oldstate->done(fd, olddata);
-	    free(oldstate);
+	    oldstate->tmp_fd = fd;
+	    oldstate->done_cbdata = olddata;
+	    sel_run(&oldstate->done_runner, finish_oldstate, oldstate);
 	}
     }
     return 0;
 }
 
-/* Clear the handlers for a file descriptor and remove it from
-   select's monitoring. */
-void
-sel_clear_fd_handlers(struct selector_s *sel,
-		      int        fd)
+static void
+i_sel_clear_fd_handler(struct selector_s *sel, int fd, int imm)
 {
     fd_control_t *fdc;
     fd_state_t   *oldstate = NULL;
@@ -428,7 +458,8 @@ sel_clear_fd_handlers(struct selector_s *sel,
 	olddata = fdc->data;
 	fdc->state = NULL;
 
-	sel_update_epoll(sel, fd, EPOLL_CTL_DEL);
+	sel_update_epoll(sel, fd, EPOLL_CTL_DEL, 0);
+	fdc->saved_events = 0;
     }
 
     init_fd(fdc);
@@ -447,14 +478,34 @@ sel_clear_fd_handlers(struct selector_s *sel,
 
     if (oldstate) {
 	oldstate->deleted = 1;
-	if (oldstate->use_count == 0) {
-	    if (oldstate->done)
-		oldstate->done(fd, olddata);
-	    free(oldstate);
+	if (imm) {
+	    assert(oldstate->use_count == 0);
+	} else if (oldstate->use_count == 0) {
+	    oldstate->tmp_fd = fd;
+	    oldstate->done_cbdata = olddata;
+	    sel_run(&oldstate->done_runner, finish_oldstate, oldstate);
 	}
     }
 }
 
+/* Clear the handlers for a file descriptor and remove it from
+   select's monitoring. */
+void
+sel_clear_fd_handlers(struct selector_s *sel, int fd)
+{
+    i_sel_clear_fd_handler(sel, fd, 0);
+}
+
+/* Clear the handlers for a file descriptor and remove it from
+   select's monitoring, except this can only be called if no
+   callbacks are active (like you haven't started listening
+   yet).  If a callback is active, it will assert. */
+void
+sel_clear_fd_handlers_imm(struct selector_s *sel, int fd)
+{
+    i_sel_clear_fd_handler(sel, fd, 1);
+}
+
 /* Set whether the file descriptor will be monitored for data ready to
    read on the file descriptor. */
 void
@@ -475,7 +526,8 @@ sel_set_fd_read_handler(struct selector_s *sel, int fd, int state)
 	    goto out;
 	FD_CLR(fd, &sel->read_set);
     }
-    if (sel_update_epoll(sel, fd, EPOLL_CTL_MOD)) {
+    if (sel_update_epoll(sel, fd, EPOLL_CTL_MOD,
+			 state == SEL_FD_HANDLER_ENABLED)) {
 	wake_fd_sel_thread(sel);
 	return;
     }
@@ -504,7 +556,7 @@ sel_set_fd_write_handler(struct selector_s *sel, int fd, int state)
 	    goto out;
 	FD_CLR(fd, &sel->write_set);
     }
-    if (sel_update_epoll(sel, fd, EPOLL_CTL_MOD)) {
+    if (sel_update_epoll(sel, fd, EPOLL_CTL_MOD, 0)) {
 	wake_fd_sel_thread(sel);
 	return;
     }
@@ -533,7 +585,7 @@ sel_set_fd_except_handler(struct selector_s *sel, int fd, int state)
 	    goto out;
 	FD_CLR(fd, &sel->except_set);
     }
-    if (sel_update_epoll(sel, fd, EPOLL_CTL_MOD)) {
+    if (sel_update_epoll(sel, fd, EPOLL_CTL_MOD, 0)) {
 	wake_fd_sel_thread(sel);
 	return;
     }
@@ -566,6 +618,19 @@ diff_timeval(struct timeval *dest,
     }
 }
 
+static void
+add_timeval(struct timeval *dest,
+	    struct timeval *left,
+	    struct timeval *right)
+{
+    dest->tv_sec = left->tv_sec + right->tv_sec;
+    dest->tv_usec = left->tv_usec + right->tv_usec;
+    while (dest->tv_usec > 1000000) {
+	dest->tv_usec -= 1000000;
+	dest->tv_sec++;
+    }
+}
+
 int
 sel_alloc_timer(struct selector_s     *sel,
 		sel_timeout_handler_t handler,
@@ -613,7 +678,7 @@ sel_start_timer(sel_timer_t    *timer,
 		struct timeval *timeout)
 {
     struct selector_s *sel = timer->val.sel;
-    volatile sel_timer_t *top;
+    volatile sel_timer_t *old_top;
 
     sel_timer_lock(sel);
     if (timer->val.in_heap) {
@@ -621,7 +686,7 @@ sel_start_timer(sel_timer_t    *timer,
 	return EBUSY;
     }
 
-    top = theap_get_top(&sel->timer_heap);
+    old_top = theap_get_top(&sel->timer_heap);
 
     timer->val.timeout = *timeout;
 
@@ -632,7 +697,7 @@ sel_start_timer(sel_timer_t    *timer,
     }
     timer->val.stopped = 0;
 
-    wake_timer_sel_thread(sel, top);
+    wake_timer_sel_thread(sel, old_top);
 
     sel_timer_unlock(sel);
 
@@ -643,7 +708,6 @@ int
 sel_stop_timer(sel_timer_t *timer)
 {
     struct selector_s *sel = timer->val.sel;
-    volatile sel_timer_t *top;
 
     sel_timer_lock(sel);
     if (timer->val.stopped) {
@@ -652,11 +716,11 @@ sel_stop_timer(sel_timer_t *timer)
     }
 
     if (timer->val.in_heap) {
-	top = theap_get_top(&sel->timer_heap);
+	volatile sel_timer_t *old_top = theap_get_top(&sel->timer_heap);
 
 	theap_remove(&sel->timer_heap, timer);
 	timer->val.in_heap = 0;
-	wake_timer_sel_thread(sel, top);
+	wake_timer_sel_thread(sel, old_top);
     }
     timer->val.stopped = 1;
 
@@ -671,34 +735,37 @@ sel_stop_timer_with_done(sel_timer_t *timer,
 			 void *cb_data)
 {
     struct selector_s *sel = timer->val.sel;
-    volatile sel_timer_t *top;
 
     sel_timer_lock(sel);
-    if (timer->val.stopped) {
+    if (timer->val.stopped || timer->val.done_handler) {
 	sel_timer_unlock(sel);
-	goto out;
+	return ETIMEDOUT;
     }
 
-    if (timer->val.in_handler) {
-	timer->val.done_handler = done_handler;
-	timer->val.done_cb_data = cb_data;
-	sel_timer_unlock(sel);
-	return 0;
-    }
+    timer->val.stopped = 1;
 
-    if (timer->val.in_heap) {
-	top = theap_get_top(&sel->timer_heap);
+    timer->val.done_handler = done_handler;
+    timer->val.done_cb_data = cb_data;
+
+    if (timer->val.in_handler)
+	goto out_unlock;
 
+    /*
+     * We don't want to run the done handler here do avoid locking
+     * issues.  So set it in_handler and stick it on the top of the
+     * heap with an immediate timeout so it will be processed now.
+     */
+    timer->val.in_handler = 1;
+    if (timer->val.in_heap) {
 	theap_remove(&sel->timer_heap, timer);
 	timer->val.in_heap = 0;
-
-	wake_timer_sel_thread(sel, top);
     }
-    timer->val.stopped = 1;
-    sel_timer_unlock(sel);
+    sel_get_monotonic_time(&timer->val.timeout);
+    theap_add(&sel->timer_heap, timer);
+    wake_timer_sel_thread(sel, NULL);
 
- out:
-    done_handler(sel, timer, cb_data);
+ out_unlock:
+    sel_timer_unlock(sel);
     return 0;
 }
 
@@ -720,32 +787,42 @@ sel_get_monotonic_time(struct timeval *tv)
  */
 static void
 process_timers(struct selector_s       *sel,
+	       unsigned int            *count,
 	       volatile struct timeval *timeout)
 {
     struct timeval now;
     sel_timer_t    *timer;
-    int            called = 0;
 
     timer = theap_get_top(&sel->timer_heap);
     sel_get_monotonic_time(&now);
     while (timer && cmp_timeval(&now, &timer->val.timeout) >= 0) {
-	called = 1;
 	theap_remove(&(sel->timer_heap), timer);
 	timer->val.in_heap = 0;
 	timer->val.stopped = 1;
-	timer->val.in_handler = 1;
-	sel_timer_unlock(sel);
-	timer->val.handler(sel, timer, timer->val.user_data);
-	sel_timer_lock(sel);
-	timer->val.in_handler = 0;
+
+	/*
+	 * A timer may be in a handler here if it has been stopped with
+	 * a done_handler.  In that case the timer was stopped, so we
+	 * don't call the main handler.
+	 */
+	if (!timer->val.in_handler) {
+	    timer->val.in_handler = 1;
+	    sel_timer_unlock(sel);
+	    timer->val.handler(sel, timer, timer->val.user_data);
+	    sel_timer_lock(sel);
+	}
+	(*count)++;
 	if (timer->val.done_handler) {
 	    sel_timeout_handler_t done_handler = timer->val.done_handler;
 	    void *done_cb_data = timer->val.done_cb_data;
+
 	    timer->val.done_handler = NULL;
+	    timer->val.in_handler = 1;
 	    sel_timer_unlock(sel);
 	    done_handler(sel, timer, done_cb_data);
 	    sel_timer_lock(sel);
 	}
+	timer->val.in_handler = 0;
 	if (timer->val.freed)
 	    free(timer);
 	else if (!timer->val.stopped) {
@@ -757,7 +834,7 @@ process_timers(struct selector_s       *sel,
 	timer = theap_get_top(&sel->timer_heap);
     }
 
-    if (called) {
+    if (*count) {
 	/* If called, set the timeout to zero. */
 	timeout->tv_sec = 0;
 	timeout->tv_usec = 0;
@@ -829,9 +906,11 @@ sel_run(sel_runner_t *runner, sel_runner_func_t func, void *cb_data)
     return 0;
 }
 
-static void
+static unsigned int
 process_runners(struct selector_s *sel)
 {
+    int count = 0;
+
     while (sel->runner_head) {
 	sel_runner_t *runner = sel->runner_head;
 	sel_runner_func_t func;
@@ -845,8 +924,11 @@ process_runners(struct selector_s *sel)
 	cb_data = runner->cb_data;
 	sel_timer_unlock(sel);
 	func(runner, cb_data);
+	count++;
 	sel_timer_lock(sel);
     }
+
+    return count;
 }
 
 static void
@@ -941,6 +1023,7 @@ process_fds_epoll(struct selector_s *sel, struct timeval *tvtimeout)
     struct epoll_event event;
     int timeout;
     sigset_t sigmask;
+    fd_control_t *fdc;
 
     if (tvtimeout->tv_sec > 600)
 	 /* Don't wait over 10 minutes, to work around an old epoll bug
@@ -964,42 +1047,65 @@ process_fds_epoll(struct selector_s *sel, struct timeval *tvtimeout)
 
     sel_fd_lock(sel);
     fd = event.data.fd;
+    fdc = (fd_control_t *) &sel->fds[fd];
+    if (event.events & (EPOLLHUP | EPOLLERR)) {
+	/*
+	 * The crazy people that designed epoll made it so that EPOLLHUP
+	 * and EPOLLERR always wake it up, even if they are not set.  That
+	 * makes this fairly inconvenient, because we don't want to wake
+	 * up in that case unless we explicitly ask for it.  Fortunately,
+	 * in those cases we can pretty easily simulate it by just deleting
+	 * it, since in those cases you will not get anything but an
+	 * EPOLLHUP or EPOLLERR, anyway, and then doing the callback
+	 * by hand.
+	 */
+	sel_update_epoll(sel, fd, EPOLL_CTL_DEL, 0);
+	fdc->saved_events = event.events & (EPOLLHUP | EPOLLERR);
+    }
     if (event.events & (EPOLLIN | EPOLLHUP))
-	handle_selector_call(sel, fd, &sel->read_set,
-			     sel->fds[fd].handle_read);
+	handle_selector_call(sel, fd, &sel->read_set, fdc->handle_read);
     if (event.events & EPOLLOUT)
-	handle_selector_call(sel, fd, &sel->write_set,
-			     sel->fds[fd].handle_write);
-    if (event.events & (EPOLLERR | EPOLLPRI))
-	handle_selector_call(sel, fd, &sel->except_set,
-			     sel->fds[fd].handle_except);
+	handle_selector_call(sel, fd, &sel->write_set, fdc->handle_write);
+    if (event.events & (EPOLLPRI | EPOLLERR))
+	handle_selector_call(sel, fd, &sel->except_set, fdc->handle_except);
 
     /* Rearm the event.  Remember it could have been deleted in the handler. */
-    if (sel->fds[fd].state)
-	sel_update_epoll(sel, fd, EPOLL_CTL_MOD);
+    if (fdc->state)
+	sel_update_epoll(sel, fd, EPOLL_CTL_MOD, 0);
     sel_fd_unlock(sel);
 
-    return 0;
+    return rv;
 }
 #endif
 
 int
-sel_select(struct selector_s *sel,
-	   sel_send_sig_cb send_sig,
-	   long            thread_id,
-	   void            *cb_data,
-	   struct timeval  *timeout)
+sel_select_intr(struct selector_s *sel,
+		sel_send_sig_cb send_sig,
+		long            thread_id,
+		void            *cb_data,
+		struct timeval  *timeout)
 {
-    int             err;
+    int             err, old_errno;
     struct timeval  loc_timeout = { 0, 0 };
     sel_wait_list_t wait_entry;
+    unsigned int    count;
+    struct timeval  end, now;
+    int user_timeout = 0;
+
+    if (timeout) {
+	sel_get_monotonic_time(&now);
+	add_timeval(&end, &now, timeout);
+    }
 
     sel_timer_lock(sel);
-    process_runners(sel);
-    process_timers(sel, &loc_timeout);
+    count = process_runners(sel);
+    /* If count is non-zero or any timers are processed, timeout is set to 0. */
+    process_timers(sel, &count, (struct timeval *)(&loc_timeout));
     if (timeout) {
-	if (cmp_timeval(&loc_timeout, timeout) >= 0)
-	    memcpy(&loc_timeout, timeout, sizeof(loc_timeout));
+	if (cmp_timeval((struct timeval *)(&loc_timeout), timeout) >= 0) {
+	    loc_timeout = *timeout;
+	    user_timeout = 1;
+	}
     }
     add_sel_wait_list(sel, &wait_entry, send_sig, cb_data, thread_id,
 		      &loc_timeout);
@@ -1012,10 +1118,49 @@ sel_select(struct selector_s *sel,
 #endif
 	err = process_fds(sel, &loc_timeout);
 
+    old_errno = errno;
+    if (!user_timeout && !err) {
+	/*
+	 * Only return a timeout if we waited on the user's timeout
+	 * Otherwise there is a timer to process.
+	 */
+	count++;
+	err = 0;
+    }
+
     sel_timer_lock(sel);
     remove_sel_wait_list(sel, &wait_entry);
     sel_timer_unlock(sel);
 
+    if (timeout) {
+	sel_get_monotonic_time(&now);
+	diff_timeval(timeout, &end, &now);
+    }
+
+    if (err < 0) {
+	errno = old_errno;
+	return err;
+    }
+
+    return err + count;
+}
+
+int
+sel_select(struct selector_s *sel,
+	   sel_send_sig_cb send_sig,
+	   long            thread_id,
+	   void            *cb_data,
+	   struct timeval  *timeout)
+{
+    int err;
+
+    err = sel_select_intr(sel, send_sig, thread_id, cb_data, timeout);
+    if (err < 0 && errno == EINTR)
+	/*
+	 * If we get an EINTR, we don't want to report a timeout.  Just
+	 * return that we did something.
+	 */
+	return 1;
     return err;
 }
 
